#!/usr/bin/python
#
# Copyright 2009 Marcelo Boveto Shima.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA    02110-1301, USA.
#
# Author: marceloshima@gmail.com (Marcelo Boveto Shima)

import os
import string

class NXShares:
    def __init__ ( self, session, nxsessiontype ):
        self.session = session
        self.nxsessiontype = nxsessiontype
    
    def umount_all( self ):
        mpoint_file = self.session.get_mounts_file_path( )
        mpoint_file_tmp = mpoint_file + ".tmp"
        if not os.path.isfile( mpoint_file ):
            return
        mpoint = open( mpoint_file ,'r' )
        mpoint_tmp = None
        try:
            for line in mpoint.readlines():
                line = string.strip( line )
                if line is not '':
                    ret = nxsessiontype.umount_dir( line )
                    print ret
                    if ret is not 0:
                        if mpoint_tmp is None:
                            mpoint_tmp = open( mpoint_file_tmp, 'w' )
                        mpoint_tmp.write( line + "\n" )
        except OSError:
            print "Couldn't umount the share"
        
        mpoint.close( )
        if mpoint_tmp is not None:
            mpoint_tmp.close( )
        
        os.remove( mpoint_file )
        if os.path.isfile( mpoint_file_tmp ):
            os.rename( mpoint_file_tmp, mpoint_file )
            print "Could not umount every mounted location"


